#!/usr/bin/python
import sys
import HD_BaseHTTPServer
import hweb_lib

SERVER = sys.argv[1]
IP = sys.argv[2]
PORT = sys.argv[3]
DIP = sys.argv[4]
cache = 'cache-' + DIP



class Handler(HD_BaseHTTPServer.HD_BaseHTTPRequestHandler):
        HD_BaseHTTPServer.HD_BaseHTTPRequestHandler.sys_version = ""
        HD_BaseHTTPServer.HD_BaseHTTPRequestHandler.protocol_version = "HTTP/1.1"
        def do_GET(self):
                log = open('log/hwlog-'+DIP, 'a')
                sys.stderr = open('log/error.txt','a')
                [VER, resp_code, server_class] = hweb_lib.persist_ver(self.path,IP,SERVER,cache)
		HD_BaseHTTPServer.HD_BaseHTTPRequestHandler.server_version = VER 
		if resp_code == 200:
                	html = hweb_lib.serve_file()
		else:
			html = hweb_lib.send_error_page(VER, self.path, server_class, resp_code)
		content_len = len(html)
                self.send_response(resp_code)
                self.send_header("Content-Length",content_len)
                self.send_header("Connection","close")
                self.send_header("Content-type","text/html")
                self.end_headers()
               	self.wfile.write(html)
                log.write('%s:%s:[%s]\n\tRequest:%s:%s\n\tReturn:%s\n' % (IP,
                                                   PORT,
                                                   self.log_date_time_string(),
                                                   self.requestline,
						   resp_code,
                                                   self.server_version))
                for header, value in self.headers.items():
                        log.write('\t%s:%s\n' % (header, value))
                log.close()
                sys.stderr.close()
        def do_HEAD(self):
                log = open('log/hwlog-'+DIP, 'a')
                sys.stderr = open('log/error.txt','a')
                [VER, resp_code, server_class] = hweb_lib.persist_ver(self.path,IP,SERVER,cache)
                HD_BaseHTTPServer.HD_BaseHTTPRequestHandler.server_version = VER 
                self.send_response(resp_code)
                self.send_header("Connection","close")
                self.send_header("Content-type","text/html")
                self.end_headers()
                log.write('%s:%s:[%s]\n\tRequest:%s:%s\n\tReturn:%s\n' % (IP,
                                                   PORT,
                                                   self.log_date_time_string(),
                                                   self.requestline,
						   resp_code,
                                                   self.server_version))
                for header, value in self.headers.items():
                        log.write('\t%s:%s\n' % (header, value))
                log.close()
                sys.stderr.close()
	def do_POST(self):
                log = open('log/hwlog-'+DIP, 'a')
                sys.stderr = open('log/hw-error.txt','a')
                [VER, resp_code, server_class] = hweb_lib.persist_ver(self.path,IP,SERVER,cache)
                HD_BaseHTTPServer.HD_BaseHTTPRequestHandler.server_version = VER 
		if resp_code == 200:
                	html = hweb_lib.serve_file()
		else:
			html = hweb_lib.send_error_page(VER, self.path, server_class, resp_code)
		content_len = len(html)
                self.send_response(resp_code)
                self.send_header("Content-Length",content_len)
                self.send_header("Connection","close")
                self.send_header("Content-type","text/html")
                self.end_headers()
               	self.wfile.write(html)
                log.write('%s:%s:[%s]\n\tRequest:%s:%s\n\tReturn:%s\n' % (IP,
                                                   PORT,
                                                   self.log_date_time_string(),
                                                   self.requestline,
						   resp_code,
                                                   self.server_version))
                for header, value in self.headers.items():
                        log.write('\t%s:%s\n' % (header, value))
                log.close()
                sys.stderr.close()
	def do_OPTIONS(self):
                log = open('log/hwlog-'+DIP, 'a')
                sys.stderr = open('log/error.txt','a')
                [VER, resp_code, server_class] = hweb_lib.persist_ver(self.path,IP,SERVER,cache)
                HD_BaseHTTPServer.HD_BaseHTTPRequestHandler.server_version = VER 
                self.send_response(resp_code)
                self.send_header("Content-Length", "0")
		if VER[:5] == 'Micro':
			self.send_header("Accept-Ranges", "bytes")
			self.send_header("DASL", "<DAV:sql>")
                	self.send_header("Public", "OPTIONS, TRACE, GET, HEAD, DELETE, PUT, POST, COPY, MOVE, MKCOL, PROPFIND, PROPPATCH, LOCK, UNLOCK, SEARCH")
                	self.send_header("Allow", "OPTIONS, TRACE, GET, HEAD, DELETE, PUT, POST, COPY, MOVE, MKCOL, PROPFIND, PROPPATCH, LOCK, UNLOCK, SEARCH")
                	self.send_header("Cache-Control", "private")
		else:
                	self.send_header("Allow", "GET, HEAD, POST, OPTIONS")
                self.send_header("Connection","close")
                self.end_headers()
                log.write('%s:%s:[%s]\n\tRequest:%s:%s\n\tReturn:%s\n' % (IP,
                                                   PORT,
                                                   self.log_date_time_string(),
                                                   self.requestline,
						   resp_code,
                                                   self.server_version))
                for header, value in self.headers.items():
                        log.write('\t%s:%s\n' % (header, value))
                log.close()
                sys.stderr.close()
a = Handler(IP, PORT, cache)
